
package logo;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;


/*************************************************************************

	Un petit Logo minimal qui devra tre amlior par la suite

				J. Ferber - 1999-2001

				Cours de DESS TNI - Montpellier II

	@version 2.0
	@date 25/09/


**************************************************************************/


public class SimpleLogo extends JFrame implements ActionListener {

	FeuilleDessin feuille;

	Tortue courante;
	JTextField inputValue;

	public static final Dimension VGAP = new Dimension(1,5);
	public static final Dimension HGAP = new Dimension(5,1);


	// la procedure principale
	public static void main(String[] args)
	{
		System.out.println( "Logo demarre!" );
		new SimpleLogo();
	}


  	void quitter()
  	{
  		System.exit(0);
  	}


	public SimpleLogo()
	{
		super("un logo tout simple");
		logoInit();

	}

	void logoInit(){

		getContentPane().setLayout(new BorderLayout(10,10));


		// les boutons
		JToolBar toolBar = new JToolBar();
                JPanel buttonPanel = new JPanel();
		buttonPanel.add(toolBar);

		getContentPane().add(buttonPanel,"North");

		addButton(toolBar,"Effacer","Nouveau dessin","/icons/New24.gif");


		toolBar.add(Box.createRigidArea(HGAP));
		inputValue=new JTextField("45",5);
		toolBar.add(inputValue);
                addButton(toolBar, "Avancer", "Avancer 50", null);
                addButton(toolBar, "Droite", "Droite 45", null);
                addButton(toolBar, "Gauche", "Gauche 45", null);
                addButton(toolBar, "Lever", "Lever Crayon", null);
                addButton(toolBar, "Baisser", "Baisser Crayon", null);

		String[] colorStrings = {"noir", "bleu", "cyan","gris fonc","rouge",
								 "vert", "gris clair", "magenta", "orange",
								 "gris", "rose", "jaune"};

		// Create the combo box
		toolBar.add(Box.createRigidArea(HGAP));
		JLabel colorLabel = new JLabel("   Couleur: ");
		toolBar.add(colorLabel);
		JComboBox colorList = new JComboBox(colorStrings);
		toolBar.add(colorList);

		colorList.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JComboBox cb = (JComboBox)e.getSource();
				int n = cb.getSelectedIndex();
				courante.setColor(n);
			}
		});


		// les menus
		JMenuBar menubar=new JMenuBar();
                setJMenuBar(menubar);	// on installe le menu bar
		JMenu menuFile=new JMenu("File"); // on installe le premier menu
                menubar.add(menuFile);

                addMenuItem(menuFile, "Effacer", "Effacer", KeyEvent.VK_N);
                addMenuItem(menuFile, "Quitter", "Quitter", KeyEvent.VK_Q);


		JMenu menuCommandes=new JMenu("Commandes"); // on installe le premier menu
                menubar.add(menuCommandes);
                addMenuItem(menuCommandes, "Avancer", "Avancer", -1);
                addMenuItem(menuCommandes, "Droite", "Droite", -1);
                addMenuItem(menuCommandes, "Gauche", "Gauche", -1);
                addMenuItem(menuCommandes, "Lever Crayon", "Lever", -1);
                addMenuItem(menuCommandes, "Baisser Crayon", "Baisser", -1);

		JMenu menuHelp=new JMenu("Aide"); // on installe le premier menu
                menubar.add(menuHelp);
                addMenuItem(menuHelp, "Aide", "Help", -1);
                addMenuItem(menuHelp, "A propos", "About", -1);


		setDefaultCloseOperation(EXIT_ON_CLOSE);

		// les boutons du bas
		JPanel p2 = new JPanel(new GridLayout());
		JButton b20 = new JButton("Proc1");
		p2.add(b20);
		b20.addActionListener(this);
		JButton b21 = new JButton("Proc2");
		p2.add(b21);
		b21.addActionListener(this);
		JButton b22 = new JButton("Proc3");
		p2.add(b22);
		b22.addActionListener(this);

		getContentPane().add(p2,"South");

		feuille = new FeuilleDessin();
		feuille.setBackground(Color.white);
		feuille.setPreferredSize(new Dimension(500,400));
		getContentPane().add(feuille,"Center");


		// on cre la tortue qui initialise sa position
		courante = new Tortue(feuille);

		pack();
  		setVisible(true);
	}

	String getInputValue(){
		String s = inputValue.getText();
		return(s);
	}

	/** la gestion des actions des boutons */
	public void actionPerformed(ActionEvent e)
	{
                String c = e.getActionCommand();

                // actions des boutons du haut
                if (c.equals("Avancer")) {
                                try {
                                  int v = Integer.parseInt(inputValue.getText());
                                  courante.avancer(v);
                                } catch (NumberFormatException ex){
                                        System.err.println("ce n'est pas un nombre : " + inputValue.getText());
                                }
                } else if (c.equals("Droite"))  {
                                try {
                                  int v = Integer.parseInt(inputValue.getText());
                                  courante.droite(v);
                                } catch (NumberFormatException ex){
                                        System.err.println("ce n'est pas un nombre : " + inputValue.getText());
                                }
                } else if (c.equals("Gauche"))  {
                                try {
                                  int v = Integer.parseInt(inputValue.getText());
                                  courante.gauche(v);
                                } catch (NumberFormatException ex){
                                        System.err.println("ce n'est pas un nombre : " + inputValue.getText());
                                }
                } else if (c.equals("Lever"))  courante.leverCrayon();
                else if (c.equals("Baisser"))  courante.baisserCrayon();

                // actions des boutons du bas
                else if (c.equals("Proc1"))  proc1();
                else if (c.equals("Proc2"))  proc2();
                else if (c.equals("Proc3"))  proc3();
                else if (c.equals("Effacer")) effacer();
                else if (c.equals("Quitter")) quitter();
        }

  	/** les procedures Logo qui combine plusieurs commandes..*/
	void proc1()
	{
		courante.carre();
	}

	void proc2()
	{
		courante.poly(60,8);
	}

	void proc3()
	{
	  	courante.spiral(50,40,6);
	}



  	// efface tout et reinitialise la tortue
  	void effacer()
  	{
  		feuille.reset();
  		courante.reset();
		feuille.repaint();
  	}

//utilitaires pour installer des boutons et des menus
void addButton(JComponent p, String name, String tooltiptext, String imageName) {
	  JButton b;
	  if ((imageName == null) || (imageName.equals(""))) {
              b = (JButton) p.add(new JButton(name));
	  }
	  else {
		   java.net.URL u = this.getClass().getResource(imageName);
	       if (u != null){
			  ImageIcon im = new ImageIcon (u);

			  b = (JButton) p.add(new JButton(im));
		   } else
				  b = (JButton) p.add(new JButton(name));
		   b.setActionCommand(name);
	  }

	  b.setToolTipText(tooltiptext);
	  b.setBorder(BorderFactory.createRaisedBevelBorder());
	  b.setMargin(new Insets(0,0,0,0));
	  b.addActionListener(this);
	}

	void addMenuItem(JMenu m, String label, String command, int key) {
        JMenuItem menuItem;
	menuItem = new JMenuItem(label);
        m.add(menuItem);

        menuItem.setActionCommand(command);
        menuItem.addActionListener(this);
		if (key > 0) {
			if (key != KeyEvent.VK_DELETE)
				menuItem.setAccelerator(KeyStroke.getKeyStroke(key, Event.CTRL_MASK, false));
			else
				menuItem.setAccelerator(KeyStroke.getKeyStroke(key, 0, false));
		}
	}


}
